diff --recursive -P -C3 slashem-0.0.7E7F2/src/dungeon.c slethe-0.0.7E7F2/src/dungeon.c
*** slashem-0.0.7E7F2/src/dungeon.c	2005-12-04 15:58:27.000000000 +0100
--- slethe-0.0.7E7F2/src/dungeon.c	2006-05-28 15:33:02.085823320 +0200
***************
*** 608,628 ****
  	{ "bigroom",	&bigroom_level },
  	{ "castle",	&stronghold_level },
  	{ "earth",	&earth_level },
! 	{ "fakewiz1",	&portal_level },
  	{ "fire",	&fire_level },
  	{ "juiblex",	&juiblex_level },
  	{ "knox",	&knox_level },
  #ifdef BLACKMARKET        
  	{ "blkmar",     &blackmarket_level },
  #endif /* BLACKMARKET */
  	{ "medusa",	&medusa_level },
  	{ "mine_end",   &mineend_level },        
  	{ "oracle",	&oracle_level },
  	{ "orcus",	&orcus_level },
  #ifdef REINCARNATION
  	{ "rogue",	&rogue_level },
  #endif
  	{ "sanctum",	&sanctum_level },
  	{ "valley",	&valley_level },
  	{ "water",	&water_level },
  	{ "wizard1",	&wiz1_level },
--- 608,631 ----
  	{ "bigroom",	&bigroom_level },
  	{ "castle",	&stronghold_level },
  	{ "earth",	&earth_level },
! 	{ "nkai-b",	&portal_level },
  	{ "fire",	&fire_level },
  	{ "juiblex",	&juiblex_level },
  	{ "knox",	&knox_level },
  #ifdef BLACKMARKET        
  	{ "blkmar",     &blackmarket_level },
  #endif /* BLACKMARKET */
+ 	{ "lethe-z",	&lethe_last_level },
  	{ "medusa",	&medusa_level },
  	{ "mine_end",   &mineend_level },        
  	{ "oracle",	&oracle_level },
  	{ "orcus",	&orcus_level },
+ 	{ "pvalley",    &pvalley_level },
  #ifdef REINCARNATION
  	{ "rogue",	&rogue_level },
  #endif
  	{ "sanctum",	&sanctum_level },
+ 	{ "ucastle",    &ucastle_level },
  	{ "valley",	&valley_level },
  	{ "water",	&water_level },
  	{ "wizard1",	&wiz1_level },
***************
*** 1202,1208 ****
  Can_fall_thru(lev)
  d_level *lev;
  {
! 	return((boolean)(Can_dig_down(lev) || Is_stronghold(lev)));
  }
  
  /*
--- 1205,1211 ----
  Can_fall_thru(lev)
  d_level *lev;
  {
! 	return((boolean)(Can_dig_down(lev)));
  }
  
  /*
***************
*** 1251,1257 ****
  	} else if (levnum > dungeons[dgn].depth_start
  			    + dungeons[dgn].num_dunlevs - 1) {
  	    /* beyond end of dungeon, jump to last level */
! 	    levnum = dungeons[dgn].num_dunlevs;
  	} else {
  	    /* The desired level is in this dungeon or a "higher" one. */
  
--- 1254,1292 ----
  	} else if (levnum > dungeons[dgn].depth_start
  			    + dungeons[dgn].num_dunlevs - 1) {
  	    /* beyond end of dungeon, jump to last level */
! 	    /* levnum = dungeons[dgn].num_dunlevs; */
! 	    /* Lethe change... */
! 	    /* In dungeons 0 and 1, we can try the next dungeon... */
! 	    switch (dgn) {
! 
! 		case 0:   /* Dungeons of Doom */
! 		    dgn = 1;
! 		    if (levnum <= dungeons[dgn].depth_start
! 			    + dungeons[dgn].num_dunlevs - 1) {
! 			levnum = levnum - dungeons[dgn].depth_start + 1;
! 			break;
! 		    }
! 		
! 		case 1:   /* Lethe Gorge */
! 		    dgn = 2;
! 		    if (levnum <= dungeons[dgn].depth_start
! 			    + dungeons[dgn].num_dunlevs - 2) {
! 			levnum = levnum - dungeons[dgn].depth_start + 1;
! 			break;
! 		    }
! 		    /* I really dont know why this part was added - if it is
!                        beyond end of gehennom, we can just cap it down */
! //		    dgn = 1;
! //		    impossible("Teleport extension beyond Lethe failed!");
! 		
! 		default:  /* beyond end of dungeon, jump to last level */
! 		    levnum = dungeons[dgn].num_dunlevs - ((dgn == 2 && !u.uevent.invoked
! #ifdef WIZARD
! 			&& !wizard
! #endif
! 			)?1:0);
! 		    break;
! 	    }				    
  	} else {
  	    /* The desired level is in this dungeon or a "higher" one. */
  
***************
*** 1405,1410 ****
--- 1440,1463 ----
  #ifdef OVL1
  
  void
+ find_castle_dungeon(lev)      /* sets *lev to be the the castle dungeon... */
+ d_level *lev;
+ {
+     lev->dnum = ucastle_level.dnum;
+     lev->dlevel = 1;
+ }
+ 
+ void
+ goto_prision(at_stairs, falling)      /* go directly to the castle dungeon... */
+ boolean       at_stairs, falling;
+ {
+     d_level lev;
+ 
+     find_castle_dungeon(&lev);
+     goto_level(&lev, at_stairs, falling, FALSE);
+ }
+ 
+ void
  find_hell(lev)	/* sets *lev to be the gateway to Gehennom... */
  d_level *lev;
  {
diff --recursive -P -C3 slashem-0.0.7E7F2/src/end.c slethe-0.0.7E7F2/src/end.c
*** slashem-0.0.7E7F2/src/end.c	2005-12-04 15:58:27.000000000 +0100
--- slethe-0.0.7E7F2/src/end.c	2006-05-28 15:31:15.796981680 +0200
***************
*** 640,645 ****
--- 640,691 ----
  			return;
  		}
  	}
+ 
+ 	/* Lethe */
+ 	/* Python sketch to the rescue... */
+ 
+ 	if ( how < GENOCIDED
+ 	  && Unchanging
+ 	  && Upolyd
+ 	  && u.umonnum == PM_PARROT ) {
+ 	
+ 	    register struct monst *shpk;
+ 
+ 	    shpk = shop_keeper(inside_shop(u.ux, u.uy));
+ 
+ 	    if ( shpk != NULL
+ 	      && inhishop(shpk)
+ 	      && !shpk->msleeping
+ 	      && shpk->mcanmove ) {
+ 		You("die...");
+ 
+ 		mark_synch();   /* flush buffered screen output */
+ 
+ 		if (ANGRY(shpk)) {
+ 		    pline("%s glowers at your corpse.", Monnam(shpk));
+ 		    pline("%s says 'My, my, a dead parrot.  How uncommon.'", Monnam(shpk));
+ 		    pline("%s says 'Time to make some parrot pie.'", Monnam(shpk));
+ 		} else {
+ 		    pline("%s scowls a your corpse.", Monnam(shpk));
+ 		    pline("%s says 'You're not dead!  You're only resting!'", Monnam(shpk));
+ 		    pline("%s says 'Get up you lazy bugger!'", Monnam(shpk));
+ 
+ 		    (void) adjattrib(A_CON, -1, TRUE);
+ 
+ 		    if(u.mhmax <= 0) {
+ 			u.mhmax = 10;   /* arbitrary */
+ 		    }
+ 
+ 		    savelife(how);
+ 
+ 		    killer = 0;
+ 		    killer_format = 0;
+ 
+ 		    return;
+ 		}
+ 	    }
+ 	}
+ 	
  	if ((
  #ifdef WIZARD
  			wizard ||
diff --recursive -P -C3 slashem-0.0.7E7F2/src/gypsy.c slethe-0.0.7E7F2/src/gypsy.c
*** slashem-0.0.7E7F2/src/gypsy.c	2005-12-04 15:58:27.000000000 +0100
--- slethe-0.0.7E7F2/src/gypsy.c	2006-05-28 15:33:02.089822712 +0200
***************
*** 316,322 ****
  			if (u.uevent.udemigod)
  				resurrect();
  			else
! 				fortune_lev(mtmp, "fakewiz1",
  					"an entrance to the Wizard's tower");
  				/*fortune_lev(mtmp, &portal_level);*/
  			break;
--- 316,322 ----
  			if (u.uevent.udemigod)
  				resurrect();
  			else
! 				fortune_lev(mtmp, "nkai-b",
  					"an entrance to the Wizard's tower");
  				/*fortune_lev(mtmp, &portal_level);*/
  			break;
diff --recursive -P -C3 slashem-0.0.7E7F2/src/makemon.c slethe-0.0.7E7F2/src/makemon.c
*** slashem-0.0.7E7F2/src/makemon.c	2005-12-04 15:58:27.000000000 +0100
--- slethe-0.0.7E7F2/src/makemon.c	2006-05-28 15:31:15.803980616 +0200
***************
*** 1728,1743 ****
  /* returns TRUE iff you know monsters have been created */
  
  boolean
! create_critters(cnt, mptr)
  int cnt;
  struct permonst *mptr;		/* usually null; used for confused reading */
  {
  	coord c;
  	int x, y;
! 	struct monst *mon;
  	boolean known = FALSE;
  #ifdef WIZARD
  	boolean ask = wizard;
  #endif
  
  	while (cnt--) {
--- 1728,1749 ----
  /* returns TRUE iff you know monsters have been created */
  
  boolean
! create_critters(cnt, mptr, mood)
  int cnt;
  struct permonst *mptr;		/* usually null; used for confused reading */
+ int mood;
  {
  	coord c;
  	int x, y;
! 	struct monst *mon, *mon2;
  	boolean known = FALSE;
  #ifdef WIZARD
  	boolean ask = wizard;
+ 
+ 	if (mptr != (struct permonst *)0) {
+ 	    ask = FALSE;
+ 	}
+ 		
  #endif
  
  	while (cnt--) {
***************
*** 1757,1763 ****
  		x = c.x,  y = c.y;
  
  	    mon = makemon(mptr, x, y, NO_MM_FLAGS);
! 	    if (mon && canspotmon(mon)) known = TRUE;
  	}
  	return known;
  }
--- 1763,1791 ----
  		x = c.x,  y = c.y;
  
  	    mon = makemon(mptr, x, y, NO_MM_FLAGS);
! 
! 	    if (mon) {
! 		switch (mood) {
! 		    case MAKE_EM_TAME:
! 			mon2 = tamedog(mon, (struct obj *)0);
! 			if (mon2) {
! 			    mon = mon2;
! 			}
! 			break;
! 		    case MAKE_EM_PEACEFUL:
! 			mon->mpeaceful = TRUE;
! 			break;
! 		    case MAKE_EM_HOSTILE:
! 			setmangry(mon);
! 			break;
! 		    default:
! 			break;
! 		}
! 		if (canspotmon(mon)) {
! 		    known = TRUE;
! 		}
! 	    }
! 
  	}
  	return known;
  }
diff --recursive -P -C3 slashem-0.0.7E7F2/src/mkmaze.c slethe-0.0.7E7F2/src/mkmaze.c
*** slashem-0.0.7E7F2/src/mkmaze.c	2005-12-04 15:58:27.000000000 +0100
--- slethe-0.0.7E7F2/src/mkmaze.c	2006-05-28 15:31:15.808979856 +0200
***************
*** 540,551 ****
      } else if (Role_if(PM_PRIEST) && In_quest(&u.uz)) {
  	/* less chance for undead corpses (lured from lower morgues) */
  	level.flags.graveyard = 1;
-     } else if (Is_stronghold(&u.uz)) {
- 	level.flags.graveyard = 1;
-     } else if(Is_sanctum(&u.uz)) {
- 	croom = search_special(TEMPLE);
- 
- 	create_secret_door(croom, W_ANY);
      } else if(on_level(&u.uz, &orcus_level)) {
  	   register struct monst *mtmp, *mtmp2;
  
--- 540,545 ----
***************
*** 573,578 ****
--- 567,621 ----
      num_lregions = 0;
  }
  
+ /* Pick a spot for the vibrating square... */
+ 
+ void
+ mkvsquare()
+ {
+ 	int x,y;
+ #define x_maze_min 2
+ #define y_maze_min 2
+ 	/*
+ 	+            * Pick a position where the stairs down to Moloch's Sanctum
+ 	+            * level will ultimately be created.  At that time, an area
+ 	+            * will be altered:  walls removed, moat and traps generated,
+ 	+            * boulders destroyed.  The position picked here must ensure
+ 	+            * that that invocation area won't extend off the map.
+ 	+            *
+ 	+            * We actually allow up to 2 squares around the usual edge of
+ 	+            * the area to get truncated; see mkinvokearea(mklev.c).
+ 	+            */
+ #define INVPOS_X_MARGIN (6 - 2)
+ #define INVPOS_Y_MARGIN (5 - 2)
+ #define INVPOS_DISTANCE 11
+ 	int x_range = x_maze_max - x_maze_min - 2*INVPOS_X_MARGIN - 1,
+ 	    y_range = y_maze_max - y_maze_min - 2*INVPOS_Y_MARGIN - 1;
+ 
+ #ifdef DEBUG
+ 	if (x_range <= INVPOS_X_MARGIN || y_range <= INVPOS_Y_MARGIN ||
+ 		(x_range * y_range) <= (INVPOS_DISTANCE * INVPOS_DISTANCE))
+ 	    panic("inv_pos: maze is too small! (%d x %d)",
+ 		    x_maze_max, y_maze_max);
+ #endif
+ 	inv_pos.x = inv_pos.y = 0; /*{occupied() => invocation_pos()}*/
+ 	do {
+ 	    x = rn1(x_range, x_maze_min + INVPOS_X_MARGIN + 1);
+ 	    y = rn1(y_range, y_maze_min + INVPOS_Y_MARGIN + 1);
+ 	    /* we don't want it to be too near the stairs, nor
+ 		to be on a spot that's already in use (wall|trap) */
+ 	} while (x == xupstair || y == yupstair ||  /*(direct line)*/
+ 		abs(x - xupstair) == abs(y - yupstair) ||
+ 		distmin(x, y, xupstair, yupstair) <= INVPOS_DISTANCE ||
+ 		!SPACE_POS(levl[x][y].typ) || occupied(x, y));
+ 	inv_pos.x = x;
+ 	inv_pos.y = y;
+ #undef INVPOS_X_MARGIN
+ #undef INVPOS_Y_MARGIN
+ #undef INVPOS_DISTANCE
+ #undef x_maze_min
+ #undef y_maze_min
+ }
+ 
  void
  makemaz(s)
  register const char *s;
***************
*** 629,634 ****
--- 672,681 ----
  	    Strcat(protofile, LEV_EXT);
  	    if(load_special(protofile)) {
  		fixup_special();
+ 		/* Allow a special level on the invokation level... */
+ 		if (Invocation_lev(&u.uz)) {
+ 		    mkvsquare();
+ 		}
  		/* some levels can end up with monsters
  		   on dead mon list, including light source monsters */
  		dmonsfree();
***************
*** 663,709 ****
  	    mazexy(&mm);
  	    mkstairs(mm.x, mm.y, 0, (struct mkroom *)0);	/* down */
  	} else {	/* choose "vibrating square" location */
! #define x_maze_min 2
! #define y_maze_min 2
! 	    /*
! 	     * Pick a position where the stairs down to Moloch's Sanctum
! 	     * level will ultimately be created.  At that time, an area
! 	     * will be altered:  walls removed, moat and traps generated,
! 	     * boulders destroyed.  The position picked here must ensure
! 	     * that that invocation area won't extend off the map.
! 	     *
! 	     * We actually allow up to 2 squares around the usual edge of
! 	     * the area to get truncated; see mkinvokearea(mklev.c).
! 	     */
! #define INVPOS_X_MARGIN (6 - 2)
! #define INVPOS_Y_MARGIN (5 - 2)
! #define INVPOS_DISTANCE 11
! 	    int x_range = x_maze_max - x_maze_min - 2*INVPOS_X_MARGIN - 1,
! 		y_range = y_maze_max - y_maze_min - 2*INVPOS_Y_MARGIN - 1;
! 
! #ifdef DEBUG
! 	    if (x_range <= INVPOS_X_MARGIN || y_range <= INVPOS_Y_MARGIN ||
! 		   (x_range * y_range) <= (INVPOS_DISTANCE * INVPOS_DISTANCE))
! 		panic("inv_pos: maze is too small! (%d x %d)",
! 		      x_maze_max, y_maze_max);
! #endif
! 	    inv_pos.x = inv_pos.y = 0; /*{occupied() => invocation_pos()}*/
! 	    do {
! 		x = rn1(x_range, x_maze_min + INVPOS_X_MARGIN + 1);
! 		y = rn1(y_range, y_maze_min + INVPOS_Y_MARGIN + 1);
! 		/* we don't want it to be too near the stairs, nor
! 		   to be on a spot that's already in use (wall|trap) */
! 	    } while (x == xupstair || y == yupstair ||	/*(direct line)*/
! 		     abs(x - xupstair) == abs(y - yupstair) ||
! 		     distmin(x, y, xupstair, yupstair) <= INVPOS_DISTANCE ||
! 		     !SPACE_POS(levl[x][y].typ) || occupied(x, y));
! 	    inv_pos.x = x;
! 	    inv_pos.y = y;
! #undef INVPOS_X_MARGIN
! #undef INVPOS_Y_MARGIN
! #undef INVPOS_DISTANCE
! #undef x_maze_min
! #undef y_maze_min
  	}
  
  	/* place branch stair or portal */
--- 710,716 ----
  	    mazexy(&mm);
  	    mkstairs(mm.x, mm.y, 0, (struct mkroom *)0);	/* down */
  	} else {	/* choose "vibrating square" location */
! 	    mkvsquare();
  	}
  
  	/* place branch stair or portal */
diff --recursive -P -C3 slashem-0.0.7E7F2/src/mon.c slethe-0.0.7E7F2/src/mon.c
*** slashem-0.0.7E7F2/src/mon.c	2005-12-04 15:58:27.000000000 +0100
--- slethe-0.0.7E7F2/src/mon.c	2006-05-28 15:31:15.817978488 +0200
***************
*** 1794,1810 ****
  		(2 + ((int)(mdat->geno & G_FREQ)<2) + verysmall(mdat))));
  }
  
  /* drop (perhaps) a cadaver and remove monster */
  void
  mondied(mdef)
  register struct monst *mdef;
  {
  	mondead(mdef);
  	if (mdef->mhp > 0) return;	/* lifesaved */
  
! 	if (corpse_chance(mdef, (struct monst *)0, FALSE) &&
! 	    (accessible(mdef->mx, mdef->my) || is_pool(mdef->mx, mdef->my)))
! 		(void) make_corpse(mdef);
  }
  
  /* monster disappears, not dies */
--- 1794,1848 ----
  		(2 + ((int)(mdat->geno & G_FREQ)<2) + verysmall(mdat))));
  }
  
+ /* Check for parrots dieing in shops... */
+ void
+ check_parrot(corpse)
+ register struct obj *corpse;
+ {
+ 	register struct monst *shkp;
+ 
+ 	/* Find the shopkeeper... */
+ 
+ 	shkp = shop_keeper(inside_shop(corpse->ox, corpse->oy));
+ 
+ 	/* Must have an alive, awake and mobile shop keeper... */
+ 
+ 	if ( shkp == NULL
+ 	  || !inhishop(shkp)
+ 	  || shkp->msleeping
+ 	  || !shkp->mcanmove ) {
+ 	    return;
+ 	}
+ 
+ 	revive_parrot(shkp, corpse);
+ 
+ 	return;
+ }
+ 
  /* drop (perhaps) a cadaver and remove monster */
  void
  mondied(mdef)
  register struct monst *mdef;
  {
+ 	register struct obj *corpse;
+ 	register struct permonst *mdat;
+ 	int mndx;
+ 
  	mondead(mdef);
  	if (mdef->mhp > 0) return;	/* lifesaved */
  
! 	corpse = NULL;
! 
! 	if (corpse_chance(mdef, (struct monst*)0, FALSE))
! 	    corpse = make_corpse(mdef);
! 
! 	if (corpse != NULL) {
! 	    mdat = mdef->data;
! 	    mndx = monsndx(mdat);
! 	    if (mndx == PM_PARROT) {
! 		check_parrot(corpse);
! 	    }
! 	}
  }
  
  /* monster disappears, not dies */
***************
*** 2015,2025 ****
--- 2053,2066 ----
  	register struct permonst *mdat;
  	int mndx;
  	register struct obj *otmp;
+ 	register struct obj *corpse;
  	register struct trap *t;
  	boolean redisp = FALSE;
  	boolean wasinside = u.uswallow && (u.ustuck == mtmp);
  
  
+ 	corpse = NULL;
+ 
  	/* KMH, conduct */
  	u.uconduct.killer++;
  
***************
*** 2117,2123 ****
  		 * if we want both, we have to specify it explicitly.
  		 */
  		if (corpse_chance(mtmp, (struct monst *)0, FALSE))
! 			(void) make_corpse(mtmp);
  	}
  	if(redisp) newsym(x,y);
  cleanup:
--- 2158,2164 ----
  		 * if we want both, we have to specify it explicitly.
  		 */
  		if (corpse_chance(mtmp, (struct monst *)0, FALSE))
! 			corpse = make_corpse(mtmp);
  	}
  	if(redisp) newsym(x,y);
  cleanup:
***************
*** 2172,2177 ****
--- 2213,2227 ----
  
  	/* malign was already adjusted for u.ualign.type and randomization */
  	adjalign(mtmp->malign);
+ 
+ 	/* Some monsters just won't stay dead... */
+ 
+ 	if ( mndx == PM_PARROT
+ 		&& corpse != NULL) {
+ 	    check_parrot(corpse);
+ 	}
+ 
+ 	return;		
  }
  
  /* changes the monster into a stone monster of the same type */
diff --recursive -P -C3 slashem-0.0.7E7F2/src/muse.c slethe-0.0.7E7F2/src/muse.c
*** slashem-0.0.7E7F2/src/muse.c	2005-12-04 15:58:27.000000000 +0100
--- slethe-0.0.7E7F2/src/muse.c	2006-05-28 15:31:15.824977424 +0200
***************
*** 245,250 ****
--- 245,254 ----
  #define MUSE_WAN_EXTRA_HEALING 21
  #define MUSE_WAN_CREATE_HORDE 22
  #define MUSE_POT_VAMPIRE_BLOOD 23
+ /* Lethe */
+ #define MUSE_SCR_DEMONOLOGY 24
+ #define MUSE_SCR_ELEMENTALISM 25
+ 
  /*
  #define MUSE_INNATE_TPT 9999
   * We cannot use this.  Since monsters get unlimited teleportation, if they
***************
*** 546,551 ****
--- 550,565 ----
  			m.has_defense = MUSE_WAN_CREATE_MONSTER;
  		}
  	    }
+ 		nomore(MUSE_SCR_DEMONOLOGY);
+ 		if(obj->otyp == SCR_DEMONOLOGY) {
+ 			m.defensive = obj;
+ 			m.has_defense = MUSE_SCR_DEMONOLOGY;
+ 		}
+ 		nomore(MUSE_SCR_ELEMENTALISM);
+ 		if(obj->otyp == SCR_ELEMENTALISM) {
+ 			m.defensive = obj;
+ 			m.has_defense = MUSE_SCR_ELEMENTALISM;
+ 		}
  		nomore(MUSE_SCR_CREATE_MONSTER);
  		if(obj->otyp == SCR_CREATE_MONSTER) {
  			m.defensive = obj;
***************
*** 780,785 ****
--- 794,950 ----
  		m_useup(mtmp, otmp);
  		return 2;
  	    }
+ 	case MUSE_SCR_DEMONOLOGY:
+ 	    {	coord cc;
+ 		struct permonst *pm = 0, *fish = 0;
+ 		int cnt = 1;
+ 		struct monst *mon;
+ 		boolean known = FALSE;
+ 
+ 		if (!rn2(73)) cnt += rnd(4);
+ 		if (mtmp->mconf || otmp->cursed) cnt += rn2(8);
+ 		if (mtmp->mconf) pm = fish = &mons[PM_MANES];
+ 		else if (is_pool(mtmp->mx, mtmp->my))
+ 		    fish = &mons[PM_WATER_DEMON];
+ 		mreadmsg(mtmp, otmp);
+ 		/* Pick a demon time... */
+ 		if (!pm) {
+ 			switch(rn2(20)) {
+ 				case  0:
+ 				case  1:
+ 					pm = &mons[PM_MANES];
+ 					cnt += rn2(4);
+ 					break;
+ 				case  2:
+ 				case  3:
+ 					pm = &mons[PM_WATER_DEMON];
+ 					break;
+ 				case  4:
+ 				case  5:
+ 					pm = &mons[PM_HORNED_DEVIL];
+ 					break;
+ 				case  6:
+ 				case  7:
+ 					pm = &mons[PM_SUCCUBUS];
+ 					break;
+ 				case  8:
+ 				case  9:
+ 					pm = &mons[PM_INCUBUS];
+ 					break;
+ 				case 10:
+ 				case 11:
+ 					pm = &mons[PM_VROCK];
+ 					break;
+ 				case 12:
+ 					pm = &mons[PM_HEZROU];
+ 					break;
+ 				case 13:
+ 					pm = &mons[PM_BARBED_DEVIL];
+ 					break;
+ 				case 14:
+ 					pm = &mons[PM_MARILITH];
+ 					break;
+ 				case 15:
+ 					pm = &mons[PM_BONE_DEVIL];
+ 					break;
+ 				case 16:
+ 					pm = &mons[PM_ICE_DEVIL];
+ 					break;
+ 				case 17:
+ 					pm = &mons[PM_NALFESHNEE];
+ 					break;
+ 				case 18:
+ 					pm = &mons[PM_PIT_FIEND];
+ 					break;
+ 				case 19:
+ 					pm = &mons[PM_BALROG];
+ 					break;
+ 			}
+ 		}
+ 		while(cnt--) {
+ 		    /* `fish' potentially gives bias towards water locations;
+ 		       `pm' is what to actually create (0 => random) */
+ 		    if (!enexto(&cc, mtmp->mx, mtmp->my, fish)) break;
+ 		    mon = makemon(pm, cc.x, cc.y, NO_MM_FLAGS);
+ 		    if (mon && canspotmon(mon)) known = TRUE;
+ 		}
+ 		/* The only case where we don't use oseen.  For wands, you
+ 		 * have to be able to see the monster zap the wand to know
+ 		 * what type it is.  For teleport scrolls, you have to see
+ 		 * the monster to know it teleported.
+ 		 */
+ 		if (known)
+ 		    makeknown(SCR_DEMONOLOGY);
+ 		else if (!objects[SCR_DEMONOLOGY].oc_name_known
+ 			&& !objects[SCR_DEMONOLOGY].oc_uname)
+ 		    docall(otmp);
+ 		m_useup(mtmp, otmp);
+ 		return 2;
+ 	    }
+ 	case MUSE_SCR_ELEMENTALISM:
+ 	    {	coord cc;
+ 		struct permonst *pm = 0, *fish = 0;
+ 		int cnt = 1;
+ 		struct monst *mon;
+ 		boolean known = FALSE;
+ 
+ 		if (!rn2(73)) cnt += rnd(4);
+ 		if (mtmp->mconf || otmp->cursed) cnt += rn2(8);
+ 		if (mtmp->mconf) pm = fish = &mons[PM_MANES];
+ 		else if (is_pool(mtmp->mx, mtmp->my))
+ 		    fish = &mons[PM_WATER_ELEMENTAL];
+ 		mreadmsg(mtmp, otmp);
+ 		/* Pick an elemental time... */
+ 		switch(rn2(4)) {
+ 		    case  0:			/* Air */
+ 			if (mtmp->mconf) {
+ 			    pm = &mons[PM_GAS_SPORE];
+ 			} else {
+ 			    pm = &mons[PM_AIR_ELEMENTAL];
+ 			}
+ 			break;
+ 		    case  1:			/* Fire */
+ 			if (mtmp->mconf) {
+ 			    pm = &mons[PM_FLAMING_SPHERE];
+ 			} else {
+ 			    pm = &mons[PM_FIRE_ELEMENTAL];
+ 			}
+ 			break;
+ 		    case  2:			/* Water */
+ 			if (mtmp->mconf) {
+ 			    pm = &mons[PM_FREEZING_SPHERE];
+ 			} else {
+ 			    pm = &mons[PM_WATER_ELEMENTAL];
+ 			}
+ 			break;
+ 		    case  3:			/* Earth */
+ 			if (mtmp->mconf) {
+ 			    pm = &mons[PM_SHOCKING_SPHERE];
+ 			} else {
+ 			    pm = &mons[PM_EARTH_ELEMENTAL];
+ 			}
+ 			break;
+ 		}
+ 		while(cnt--) {
+ 		    /* `fish' potentially gives bias towards water locations;
+ 		       `pm' is what to actually create (0 => random) */
+ 		    if (!enexto(&cc, mtmp->mx, mtmp->my, fish)) break;
+ 		    mon = makemon(pm, cc.x, cc.y, NO_MM_FLAGS);
+ 		    if (mon && canspotmon(mon)) known = TRUE;
+ 		}
+ 		/* The only case where we don't use oseen.  For wands, you
+ 		 * have to be able to see the monster zap the wand to know
+ 		 * what type it is.  For teleport scrolls, you have to see
+ 		 * the monster to know it teleported.
+ 		 */
+ 		if (known)
+ 		    makeknown(SCR_ELEMENTALISM);
+ 		else if (!objects[SCR_ELEMENTALISM].oc_name_known
+ 			&& !objects[SCR_ELEMENTALISM].oc_uname)
+ 		    docall(otmp);
+ 		m_useup(mtmp, otmp);
+ 		return 2;
+ 	    }
  	case MUSE_TRAPDOOR:
  		/* trap doors on "bottom" levels of dungeons are rock-drop
  		 * trap doors, not holes in the floor.  We check here for
***************
*** 2190,2196 ****
  	    break;
  	case SCROLL_CLASS:
  	    if (typ == SCR_TELEPORTATION || typ == SCR_CREATE_MONSTER
! 		    || typ == SCR_EARTH)
  		return TRUE;
  	    break;
  	case AMULET_CLASS:
--- 2355,2362 ----
  	    break;
  	case SCROLL_CLASS:
  	    if (typ == SCR_TELEPORTATION || typ == SCR_CREATE_MONSTER
! 		    || typ == SCR_EARTH || typ == SCR_DEMONOLOGY
! 		    || typ == SCR_ELEMENTALISM) /* Lethe */
  		return TRUE;
  	    break;
  	case AMULET_CLASS:
***************
*** 2400,2402 ****
--- 2566,2569 ----
  }
  
  /*muse.c*/
+ 
diff --recursive -P -C3 slashem-0.0.7E7F2/src/objects.c slethe-0.0.7E7F2/src/objects.c
*** slashem-0.0.7E7F2/src/objects.c	2005-12-04 15:58:27.000000000 +0100
--- slethe-0.0.7E7F2/src/objects.c	2006-05-28 15:31:15.830976512 +0200
***************
*** 242,248 ****
  
  /* Quarterstaves */
  WEAPON("quarterstaff", "staff",
! 	0, 0, 1, 11, 40,  5,  6,  6, 0, B,   P_QUARTERSTAFF, WOOD, HI_WOOD),
  
  /* Polearms */
  /* (also weptool fishing pole) */
--- 242,250 ----
  
  /* Quarterstaves */
  WEAPON("quarterstaff", "staff",
! 	0, 0, 1,  8, 40,  5,  6,  6, 0, B,   P_QUARTERSTAFF, WOOD, HI_WOOD),
! WEAPON("silver capped staff", (char *)0,
! 	0, 0, 1,  3, 40,100,  6,  6, 0, B,   P_QUARTERSTAFF, SILVER, HI_SILVER),
  
  /* Polearms */
  /* (also weptool fishing pole) */
***************
*** 1012,1042 ****
  		SCROLL_CLASS, prob, 0, 5, cost, 0, 0, 0, 0, 6, HI_PAPER )
  /* Attack */
  SCROLL("create monster",        "LEP GEX VEN ZEA",      P_ATTACK_SPELL, 1,  45, 200),
  /* Enchantment */
  SCROLL("taming",                "PRIRUTSENIE",          P_ENCHANTMENT_SPELL, 1,  15, 200),
  /* Divination */
! SCROLL("light",                 "VERR YED HORRE",       P_DIVINATION_SPELL, 1,  90,  50),
  SCROLL("food detection",        "YUM YUM",              P_DIVINATION_SPELL, 1,  25, 100),
  SCROLL("gold detection",        "THARR",                P_DIVINATION_SPELL, 1,  33, 100),
! SCROLL("identify",              "KERNOD WEL",           P_DIVINATION_SPELL, 1, 185,  20),
  SCROLL("magic mapping",         "ELAM EBOW",            P_DIVINATION_SPELL, 1,  45, 100),
  /* Enchantment */
! SCROLL("confuse monster",       "NR 9",                 P_ENCHANTMENT_SPELL,  1,  43, 100),
! SCROLL("scare monster",         "XIXAXA XOXAXA XUXAXA", P_ENCHANTMENT_SPELL,  1,  35, 100),
! SCROLL("enchant weapon",        "DAIYEN FOOELS",        P_ENCHANTMENT_SPELL,  1,  80,  60),
  SCROLL("enchant armor",         "ZELGO MER",            P_ENCHANTMENT_SPELL,  1,  63,  80),
  /* Protection */
  SCROLL("remove curse",          "PRATYAVAYAH",          P_PROTECTION_SPELL, 1,  65,  80),
  /* Body */
  SCROLL("teleportation",         "VENZAR BORGAVVE",      P_BODY_SPELL, 1,  55, 100),
  /* Matter */
! SCROLL("fire",                  "ANDOVA BEGARIN",       P_MATTER_SPELL, 1,  33, 100),
! SCROLL("earth",                 "KIRJE",                P_MATTER_SPELL, 1,  20, 200),
  
  SCROLL("destroy armor",         "JUYED AWK YACC",       P_NONE, 1,  45, 100),
  SCROLL("amnesia",               "DUAM XNAHT",           P_NONE, 1,  35, 200),
  SCROLL("charging",              "HACKEM MUCHE",         P_NONE, 1,  15, 300),
! SCROLL("genocide",              "ELBIB YLOH",           P_NONE, 1,  15, 300),
  SCROLL("punishment",            "VE FORBRYDERNE",       P_NONE, 1,  15, 300),
  SCROLL("stinking cloud",	"VELOX NEB",            P_NONE, 1,  15, 300),
  SCROLL((char *)0,		"FOOBIE BLETCH",        P_NONE, 1,   0, 100),
--- 1014,1046 ----
  		SCROLL_CLASS, prob, 0, 5, cost, 0, 0, 0, 0, 6, HI_PAPER )
  /* Attack */
  SCROLL("create monster",        "LEP GEX VEN ZEA",      P_ATTACK_SPELL, 1,  45, 200),
+ SCROLL("demonology",            "IA CTHULHU",           P_ATTACK_SPELL, 1,  10, 350),
  /* Enchantment */
  SCROLL("taming",                "PRIRUTSENIE",          P_ENCHANTMENT_SPELL, 1,  15, 200),
  /* Divination */
! SCROLL("light",                 "VERR YED HORRE",       P_DIVINATION_SPELL, 1,  85,  50),
  SCROLL("food detection",        "YUM YUM",              P_DIVINATION_SPELL, 1,  25, 100),
  SCROLL("gold detection",        "THARR",                P_DIVINATION_SPELL, 1,  33, 100),
! SCROLL("identify",              "KERNOD WEL",           P_DIVINATION_SPELL, 1, 180,  20),
  SCROLL("magic mapping",         "ELAM EBOW",            P_DIVINATION_SPELL, 1,  45, 100),
  /* Enchantment */
! SCROLL("confuse monster",       "NR 9",                 P_ENCHANTMENT_SPELL,  1,  53, 100),
! SCROLL("scare monster",         "XIXAXA XOXAXA XUXAXA", P_ENCHANTMENT_SPELL,  1,  30, 100),
! SCROLL("enchant weapon",        "DAIYEN FOOELS",        P_ENCHANTMENT_SPELL,  1,  75,  60),
  SCROLL("enchant armor",         "ZELGO MER",            P_ENCHANTMENT_SPELL,  1,  63,  80),
  /* Protection */
  SCROLL("remove curse",          "PRATYAVAYAH",          P_PROTECTION_SPELL, 1,  65,  80),
  /* Body */
  SCROLL("teleportation",         "VENZAR BORGAVVE",      P_BODY_SPELL, 1,  55, 100),
  /* Matter */
! SCROLL("fire",                  "ANDOVA BEGARIN",       P_MATTER_SPELL, 1,  30, 100),
! SCROLL("earth",                 "KIRJE",                P_MATTER_SPELL, 1,  18, 200),
! SCROLL("elementalism",          "4OFAE OF9 SCC9",       P_MATTER_SPELL, 1,  10, 350),
  
  SCROLL("destroy armor",         "JUYED AWK YACC",       P_NONE, 1,  45, 100),
  SCROLL("amnesia",               "DUAM XNAHT",           P_NONE, 1,  35, 200),
  SCROLL("charging",              "HACKEM MUCHE",         P_NONE, 1,  15, 300),
! SCROLL("genocide",              "ELBIB YLOH",           P_NONE, 1,  10, 300),
  SCROLL("punishment",            "VE FORBRYDERNE",       P_NONE, 1,  15, 300),
  SCROLL("stinking cloud",	"VELOX NEB",            P_NONE, 1,  15, 300),
  SCROLL((char *)0,		"FOOBIE BLETCH",        P_NONE, 1,   0, 100),
diff --recursive -P -C3 slashem-0.0.7E7F2/src/objnam.c slethe-0.0.7E7F2/src/objnam.c
*** slashem-0.0.7E7F2/src/objnam.c	2005-12-04 15:58:27.000000000 +0100
--- slethe-0.0.7E7F2/src/objnam.c	2006-05-28 15:31:15.840974992 +0200
***************
*** 3042,3050 ****
  		delete_contents(otmp);
  	    obfree(otmp, (struct obj *) 0);
  	    otmp = &zeroobj;
! 	    pline("For a moment, you feel %s in your %s, but it disappears!",
  		  something,
! 		  makeplural(body_part(HAND)));
  	}
  
  	if (halfeaten && otmp->oclass == FOOD_CLASS) {
--- 3042,3052 ----
  		delete_contents(otmp);
  	    obfree(otmp, (struct obj *) 0);
  	    otmp = &zeroobj;
! /*	    pline("For a moment, you feel %s in your %s, but it disappears!",
  		  something,
! 		  makeplural(body_part(HAND))); */
! 	    /* Lethe message looks better for this situation... */
! 	    moloch_denies_you();
  	}
  
  	if (halfeaten && otmp->oclass == FOOD_CLASS) {
